commit 5affbd944b1c09d57519e3402ee7cfe8a141df2f
Author: freddy77 <freddy77>
Date:   Fri Oct 17 08:30:03 2008 +0000

    allow SQL_NO_TOTAL from odbc_tds2sql

diff --git a/ChangeLog b/ChangeLog
index 93f9f4d..14c7c29 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Fri Oct 17 10:26:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tdsodbc.h src/odbc/convert_tds2sql.c src/odbc/odbc.c:
+	* src/odbc/odbc_util.c:
+	- allow SQL_NO_TOTAL from odbc_tds2sql
+
 Fri Oct 17 10:13:19 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c: rollback SQLGetData changes to 1.481
 
@@ -706,4 +711,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2623 2008/10/17 08:15:21 freddy77 Exp $
+$Id: ChangeLog,v 1.2624 2008/10/17 08:30:03 freddy77 Exp $
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index f6a7f8d..7c1df42 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.111 2008/10/16 11:28:07 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.112 2008/10/17 08:30:03 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
@@ -439,7 +439,7 @@ int odbc_get_dsn_info(const char *DSN, TDSCONNECTION * connection);
 /*
  * convert_tds2sql.c
  */
-TDS_INT odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
+SQLLEN odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen, const struct _drecord *drec_ixd);
 
 /*
  * descriptor.c
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index a717f88..1df2cad 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -39,9 +39,9 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.54 2008/10/16 11:28:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.55 2008/10/17 08:30:03 freddy77 Exp $");
 
-TDS_INT
+SQLLEN
 odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
 	     const struct _drecord *drec_ixd)
 {
@@ -57,7 +57,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	TIMESTAMP_STRUCT *tssp;
 	SQL_NUMERIC_STRUCT *num;
 
-	int ret = TDS_CONVERT_FAIL;
+	SQLLEN ret = SQL_NULL_DATA;
 	int i, cplen;
 	int binary_conversion = 0;
 
@@ -68,7 +68,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	nDestSybType = odbc_c_to_server_type(desttype);
 	if (nDestSybType == TDS_FAIL) {
 		odbc_errs_add(&stmt->errs, "HY003", NULL);
-		return TDS_CONVERT_NOAVAIL;
+		return SQL_NULL_DATA;
 	}
 
 	/* special case for binary type */
@@ -81,7 +81,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 			/* prevent buffer overflow */
 			if (destlen < sizeof(SQL_NUMERIC_STRUCT)) {
 				odbc_errs_add(&stmt->errs, "07006", NULL);
-				return TDS_CONVERT_FAIL;
+				return SQL_NULL_DATA;
 			}
 			ores.n.precision = ((TDS_NUMERIC *) src)->precision;
 			ores.n.scale = ((TDS_NUMERIC *) src)->scale;
@@ -98,7 +98,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 				/* if destlen == 0 we return only length */
 				if (destlen != 0) {
 					odbc_errs_add(&stmt->errs, "07006", NULL);
-					return TDS_CONVERT_FAIL;
+					return SQL_NULL_DATA;
 				}
 			}
 			return ret;
@@ -146,7 +146,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	}
 	if (nRetVal < 0) {
 		odbc_convert_err_set(&stmt->errs, nRetVal);
-		return nRetVal;
+		return SQL_NULL_DATA;
 	}
 
 	switch (desttype) {
@@ -169,7 +169,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 		} else {
 			/* if destlen == 0 we return only length */
 			if (destlen != 0)
-				ret = TDS_CONVERT_FAIL;
+				ret = SQL_NULL_DATA;
 		}
 		break;
 
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 2e8bb3b..0b46fd0 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.500 2008/10/17 08:15:21 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.501 2008/10/17 08:30:03 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3669,7 +3669,7 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				}
 				len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
 						      src, srclen, c_type, data_ptr, drec_ard->sql_desc_octet_length, drec_ard);
-				if (len < 0) {
+				if (len == SQL_NULL_DATA) {
 					row_status = SQL_ROW_ERROR;
 					break;
 				}
@@ -4730,7 +4730,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		assert(fCType);
 
 		*pcbValue = odbc_tds2sql(stmt, colinfo, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
-		if (*pcbValue < 0)
+		if (*pcbValue == SQL_NULL_DATA)
 			ODBC_RETURN(stmt, SQL_ERROR);
 		
 		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_BINARY)) {
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index ef8b8dc..40fb59c 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.104 2008/10/16 11:28:07 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.105 2008/10/17 08:30:03 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -140,7 +140,7 @@ odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row)
 
 		len = odbc_tds2sql(stmt, NULL, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
 				   drec->sql_desc_concise_type, (void *) data_ptr, drec->sql_desc_octet_length, NULL);
-		if (len < 0)
+		if (len == SQL_NULL_DATA)
 			return /* SQL_ERROR */ ;
 		if (drec->sql_desc_indicator_ptr)
 			LEN(drec->sql_desc_indicator_ptr) = 0;
@@ -221,7 +221,7 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 		 */
 		len = odbc_tds2sql(stmt, colinfo, tds_get_conversion_type(colinfo->on_server.column_type, colinfo->on_server.column_size), src, srclen,
 				   c_type, (void *) data_ptr, drec_apd->sql_desc_octet_length, drec_ipd);
-		if (len < 0)
+		if (len == SQL_NULL_DATA)
 			return /* SQL_ERROR */ ;
 		if (drec_apd->sql_desc_indicator_ptr)
 			LEN(drec_apd->sql_desc_indicator_ptr) = 0;

